/* Copyright (c) 2004 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor prihlaseni.c */

#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "windows.h"
#include "barvy.h"
#include "nactislozku_30.h"

int
prihlaseni (char **chyba, type_uziv * slozka, type_nastaveni * nastaveni)
{
  char password[PW_LEN];
  int i;

  if (zamkni ())
    {
      endwin2 ();
      fprintf (stderr, "CHYBA: PROGRAM JE JI SPUTN!\n");
      fprintf (stderr, "%s%s%s",
	       "Pokud nen program sputn a existuje soubor \"",
	       jmeno_temp_soubor (),
	       "\",\npak tento soubor smate a spuste program znovu.\n");
      exit (1);
    }

  if (otevri_adresar (chyba))
    {
      return 1;
    }
  i = nacti_slozku (slozka, chyba);
  if (i == 2)
    {				/* prvni spusteni programu */
      global_set (g_barva, 7);
      barevne ();
      napoveda ();
#include "profi/prihlaseni-c-kompatibilita30.h"
    }
  else if (i)
    {
      return 1;
    }

  i = nacti_nastaveni (nastaveni, chyba);
  if (i == 2)
    {
      qwertz (nastaveni);
    }
  else if (i)
    {
      return 1;
    }

  if (nastaveni->spusteno <= 0)
    {
      nastaveni->spusteno--;
    }
  else
    {
      nastaveni->spusteno++;
    }
  uloz_nastaveni (nastaveni);

  (void) jmeno_nov_text (jmeno_lekce00 ());

  global_set (g_run, g_run_null);
  global_set (g_qwertz, nastaveni->qwertz ? g_q_z : g_q_y);
  global_set (g_us, nastaveni->us ? g_us_us : g_us_cz);

  if (strcmp (slozka->heslo, ""))
    {
      wattron2 (sub_hlavni, COLOR_PAIR (COLOR_PASSWORD_TEXT) | A_BOLD);
      mvwprintw2 (sub_hlavni, 1, 1, "Zadejte heslo:");
      wattron2 (sub_hlavni, COLOR_PAIR (COLOR_PASSWORD_HLAVNI) | A_BOLD);
      obnov_hlavni ();
      tiskni_dle_priority ();
      memset (password, '\0', sizeof (password) / sizeof (password[0]));
      (void) wzadej_text (sub_hlavni, password, PW_LEN, 1, 20, 0, 1);
      /* zkus porovnat nezasifrovane heslo (old) */
      if (!strncmp (password, slozka->heslo, PW_LEN))
      {
	      /* old format to new (sifrovany) format */
	      sifruj (slozka->heslo, slozka->heslo_I);
	      uloz_slozku (slozka);
      }
      sifruj (password, slozka->heslo_I);
      if (strncmp (password, slozka->heslo, PW_LEN))
	{
	  print_hl (1, "Chybn heslo!");
	  sleep (3);
	  *chyba = "            Chybn  heslo!";
	  return 1;
	}
    }
  return 0;
}
